diff --git a/target-mips/translate.c b/target-mips/translate.c
index cefccb0..590c2b6 100644
--- a/target-mips/translate.c
+++ b/target-mips/translate.c
@@ -7057,180 +7016,180 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     case FOP(24, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, ft);
             gen_load_fpr64(ctx, fp1, fs);
-            tcg_gen_helper_1_2(do_float_addr_ps, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_addr_ps(fp0, fp0, fp1);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "addr.ps";
         break;
     case FOP(26, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, ft);
             gen_load_fpr64(ctx, fp1, fs);
-            tcg_gen_helper_1_2(do_float_mulr_ps, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_mulr_ps(fp0, fp0, fp1);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "mulr.ps";
         break;
     case FOP(28, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, fd);
-            tcg_gen_helper_1_2(do_float_recip2_ps, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_recip2_ps(fp0, fp0, fp1);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "recip2.ps";
         break;
     case FOP(29, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_recip1_ps, fp0, fp0);
+            gen_helper_float_recip1_ps(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "recip1.ps";
         break;
     case FOP(30, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_rsqrt1_ps, fp0, fp0);
+            gen_helper_float_rsqrt1_ps(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "rsqrt1.ps";
         break;
     case FOP(31, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
-            tcg_gen_helper_1_2(do_float_rsqrt2_ps, fp0, fp0, fp1);
-            tcg_temp_free(fp1);
+            gen_helper_float_rsqrt2_ps(fp0, fp0, fp1);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "rsqrt2.ps";
         break;
     case FOP(32, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32h(fp0, fs);
-            tcg_gen_helper_1_1(do_float_cvts_pu, fp0, fp0);
+            gen_helper_float_cvts_pu(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "cvt.s.pu";
         break;
     case FOP(36, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
-            tcg_gen_helper_1_1(do_float_cvtpw_ps, fp0, fp0);
+            gen_helper_float_cvtpw_ps(fp0, fp0);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "cvt.pw.ps";
         break;
     case FOP(40, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_helper_1_1(do_float_cvts_pl, fp0, fp0);
+            gen_helper_float_cvts_pl(fp0, fp0);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "cvt.s.pl";
         break;
     case FOP(44, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             gen_load_fpr32(fp1, ft);
             gen_store_fpr32h(fp0, fd);
             gen_store_fpr32(fp1, fd);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            tcg_temp_free_i32(fp0);
+            tcg_temp_free_i32(fp1);
         }
         opn = "pll.ps";
         break;
     case FOP(45, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             gen_load_fpr32h(fp1, ft);
             gen_store_fpr32(fp1, fd);
             gen_store_fpr32h(fp0, fd);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            tcg_temp_free_i32(fp0);
+            tcg_temp_free_i32(fp1);
         }
         opn = "plu.ps";
         break;
     case FOP(46, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
 
             gen_load_fpr32h(fp0, fs);
             gen_load_fpr32(fp1, ft);
             gen_store_fpr32(fp1, fd);
             gen_store_fpr32h(fp0, fd);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            tcg_temp_free_i32(fp0);
+            tcg_temp_free_i32(fp1);
         }
         opn = "pul.ps";
         break;
     case FOP(47, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
 
             gen_load_fpr32h(fp0, fs);
             gen_load_fpr32h(fp1, ft);
             gen_store_fpr32(fp1, fd);
             gen_store_fpr32h(fp0, fd);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            tcg_temp_free_i32(fp0);
+            tcg_temp_free_i32(fp1);
         }
         opn = "puu.ps";
         break;
@@ -7252,8 +7211,8 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
     case FOP(63, 22):
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
@@ -7264,8 +7223,8 @@ static void gen_farith (DisasContext *ctx, uint32_t op1,
                 gen_cmp_ps(func-48, fp0, fp1, cc);
                 opn = condnames[func-48];
             }
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            tcg_temp_free_i64(fp0);
+            tcg_temp_free_i64(fp1);
         }
         break;
     default:
@@ -7292,8 +7251,8 @@ static void gen_flt3_ldst (DisasContext *ctx, uint32_t opc,
 {
     const char *opn = "extended float load/store";
     int store = 0;
-    TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
-    TCGv t1 = tcg_temp_local_new(TCG_TYPE_TL);
+    TCGv t0 = tcg_temp_local_new();
+    TCGv t1 = tcg_temp_local_new();
 
     if (base == 0) {
         gen_load_gpr(t0, index);
@@ -7310,11 +7269,12 @@ static void gen_flt3_ldst (DisasContext *ctx, uint32_t opc,
     case OPC_LWXC1:
         check_cop1x(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
-            tcg_gen_qemu_ld32s(fp0, t0, ctx->mem_idx);
+            tcg_gen_qemu_ld32s(t1, t0, ctx->mem_idx);
+            tcg_gen_trunc_tl_i32(fp0, t1);
             gen_store_fpr32(fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i32(fp0);
         }
         opn = "lwxc1";
         break;
@@ -7322,11 +7282,11 @@ static void gen_flt3_ldst (DisasContext *ctx, uint32_t opc,
         check_cop1x(ctx);
         check_cp1_registers(ctx, fd);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             tcg_gen_qemu_ld64(fp0, t0, ctx->mem_idx);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "ldxc1";
         break;
@@ -7334,22 +7294,23 @@ static void gen_flt3_ldst (DisasContext *ctx, uint32_t opc,
         check_cp1_64bitmode(ctx);
         tcg_gen_andi_tl(t0, t0, ~0x7);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             tcg_gen_qemu_ld64(fp0, t0, ctx->mem_idx);
             gen_store_fpr64(ctx, fp0, fd);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "luxc1";
         break;
     case OPC_SWXC1:
         check_cop1x(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
-            tcg_gen_qemu_st32(fp0, t0, ctx->mem_idx);
-            tcg_temp_free(fp0);
+            tcg_gen_extu_i32_tl(t1, fp0);
+            tcg_gen_qemu_st32(t1, t0, ctx->mem_idx);
+            tcg_temp_free_i32(fp0);
         }
         opn = "swxc1";
         store = 1;
@@ -7358,11 +7319,11 @@ static void gen_flt3_ldst (DisasContext *ctx, uint32_t opc,
         check_cop1x(ctx);
         check_cp1_registers(ctx, fs);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             tcg_gen_qemu_st64(fp0, t0, ctx->mem_idx);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "sdxc1";
         store = 1;
@@ -7371,11 +7332,11 @@ static void gen_flt3_ldst (DisasContext *ctx, uint32_t opc,
         check_cp1_64bitmode(ctx);
         tcg_gen_andi_tl(t0, t0, ~0x7);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             tcg_gen_qemu_st64(fp0, t0, ctx->mem_idx);
-            tcg_temp_free(fp0);
+            tcg_temp_free_i64(fp0);
         }
         opn = "suxc1";
         store = 1;
@@ -7402,11 +7363,11 @@ static void gen_flt3_arith (DisasContext *ctx, uint32_t opc,
     case OPC_ALNV_PS:
         check_cp1_64bitmode(ctx);
         {
-            TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
-            TCGv fp0 = tcg_temp_local_new(TCG_TYPE_I32);
-            TCGv fph0 = tcg_temp_local_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_local_new(TCG_TYPE_I32);
-            TCGv fph1 = tcg_temp_local_new(TCG_TYPE_I32);
+            TCGv t0 = tcg_temp_local_new();
+            TCGv_i32 fp0 = tcg_temp_local_new_i32();
+            TCGv_i32 fph0 = tcg_temp_local_new_i32();
+            TCGv_i32 fp1 = tcg_temp_local_new_i32();
+            TCGv_i32 fph1 = tcg_temp_local_new_i32();
             int l1 = gen_new_label();
             int l2 = gen_new_label();
 
@@ -7432,28 +7393,28 @@ static void gen_flt3_arith (DisasContext *ctx, uint32_t opc,
             gen_store_fpr32h(fp1, fd);
 #endif
             gen_set_label(l2);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fph0);
-            tcg_temp_free(fp1);
-            tcg_temp_free(fph1);
+            tcg_temp_free_i32(fp0);
+            tcg_temp_free_i32(fph0);
+            tcg_temp_free_i32(fp1);
+            tcg_temp_free_i32(fph1);
         }
         opn = "alnv.ps";
         break;
     case OPC_MADD_S:
         check_cop1x(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp2 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
+            TCGv_i32 fp2 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             gen_load_fpr32(fp1, ft);
             gen_load_fpr32(fp2, fr);
-            tcg_gen_helper_1_3(do_float_muladd_s, fp2, fp0, fp1, fp2);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            gen_helper_float_muladd_s(fp2, fp0, fp1, fp2);
+            tcg_temp_free_i32(fp0);
+            tcg_temp_free_i32(fp1);
             gen_store_fpr32(fp2, fd);
-            tcg_temp_free(fp2);
+            tcg_temp_free_i32(fp2);
         }
         opn = "madd.s";
         break;
@@ -7461,54 +7422,54 @@ static void gen_flt3_arith (DisasContext *ctx, uint32_t opc,
         check_cop1x(ctx);
         check_cp1_registers(ctx, fd | fs | ft | fr);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp2 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
+            TCGv_i64 fp2 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
             gen_load_fpr64(ctx, fp2, fr);
-            tcg_gen_helper_1_3(do_float_muladd_d, fp2, fp0, fp1, fp2);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            gen_helper_float_muladd_d(fp2, fp0, fp1, fp2);
+            tcg_temp_free_i64(fp0);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp2, fd);
-            tcg_temp_free(fp2);
+            tcg_temp_free_i64(fp2);
         }
         opn = "madd.d";
         break;
     case OPC_MADD_PS:
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp2 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
+            TCGv_i64 fp2 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
             gen_load_fpr64(ctx, fp2, fr);
-            tcg_gen_helper_1_3(do_float_muladd_ps, fp2, fp0, fp1, fp2);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            gen_helper_float_muladd_ps(fp2, fp0, fp1, fp2);
+            tcg_temp_free_i64(fp0);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp2, fd);
-            tcg_temp_free(fp2);
+            tcg_temp_free_i64(fp2);
         }
         opn = "madd.ps";
         break;
     case OPC_MSUB_S:
         check_cop1x(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp2 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
+            TCGv_i32 fp2 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             gen_load_fpr32(fp1, ft);
             gen_load_fpr32(fp2, fr);
-            tcg_gen_helper_1_3(do_float_mulsub_s, fp2, fp0, fp1, fp2);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            gen_helper_float_mulsub_s(fp2, fp0, fp1, fp2);
+            tcg_temp_free_i32(fp0);
+            tcg_temp_free_i32(fp1);
             gen_store_fpr32(fp2, fd);
-            tcg_temp_free(fp2);
+            tcg_temp_free_i32(fp2);
         }
         opn = "msub.s";
         break;
@@ -7516,54 +7477,54 @@ static void gen_flt3_arith (DisasContext *ctx, uint32_t opc,
         check_cop1x(ctx);
         check_cp1_registers(ctx, fd | fs | ft | fr);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp2 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
+            TCGv_i64 fp2 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
             gen_load_fpr64(ctx, fp2, fr);
-            tcg_gen_helper_1_3(do_float_mulsub_d, fp2, fp0, fp1, fp2);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            gen_helper_float_mulsub_d(fp2, fp0, fp1, fp2);
+            tcg_temp_free_i64(fp0);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp2, fd);
-            tcg_temp_free(fp2);
+            tcg_temp_free_i64(fp2);
         }
         opn = "msub.d";
         break;
     case OPC_MSUB_PS:
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp2 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
+            TCGv_i64 fp2 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
             gen_load_fpr64(ctx, fp2, fr);
-            tcg_gen_helper_1_3(do_float_mulsub_ps, fp2, fp0, fp1, fp2);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            gen_helper_float_mulsub_ps(fp2, fp0, fp1, fp2);
+            tcg_temp_free_i64(fp0);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp2, fd);
-            tcg_temp_free(fp2);
+            tcg_temp_free_i64(fp2);
         }
         opn = "msub.ps";
         break;
     case OPC_NMADD_S:
         check_cop1x(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp2 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
+            TCGv_i32 fp2 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             gen_load_fpr32(fp1, ft);
             gen_load_fpr32(fp2, fr);
-            tcg_gen_helper_1_3(do_float_nmuladd_s, fp2, fp0, fp1, fp2);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            gen_helper_float_nmuladd_s(fp2, fp0, fp1, fp2);
+            tcg_temp_free_i32(fp0);
+            tcg_temp_free_i32(fp1);
             gen_store_fpr32(fp2, fd);
-            tcg_temp_free(fp2);
+            tcg_temp_free_i32(fp2);
         }
         opn = "nmadd.s";
         break;
@@ -7571,54 +7532,54 @@ static void gen_flt3_arith (DisasContext *ctx, uint32_t opc,
         check_cop1x(ctx);
         check_cp1_registers(ctx, fd | fs | ft | fr);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp2 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
+            TCGv_i64 fp2 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
             gen_load_fpr64(ctx, fp2, fr);
-            tcg_gen_helper_1_3(do_float_nmuladd_d, fp2, fp0, fp1, fp2);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            gen_helper_float_nmuladd_d(fp2, fp0, fp1, fp2);
+            tcg_temp_free_i64(fp0);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp2, fd);
-            tcg_temp_free(fp2);
+            tcg_temp_free_i64(fp2);
         }
         opn = "nmadd.d";
         break;
     case OPC_NMADD_PS:
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp2 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
+            TCGv_i64 fp2 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
             gen_load_fpr64(ctx, fp2, fr);
-            tcg_gen_helper_1_3(do_float_nmuladd_ps, fp2, fp0, fp1, fp2);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            gen_helper_float_nmuladd_ps(fp2, fp0, fp1, fp2);
+            tcg_temp_free_i64(fp0);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp2, fd);
-            tcg_temp_free(fp2);
+            tcg_temp_free_i64(fp2);
         }
         opn = "nmadd.ps";
         break;
     case OPC_NMSUB_S:
         check_cop1x(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I32);
-            TCGv fp2 = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 fp0 = tcg_temp_new_i32();
+            TCGv_i32 fp1 = tcg_temp_new_i32();
+            TCGv_i32 fp2 = tcg_temp_new_i32();
 
             gen_load_fpr32(fp0, fs);
             gen_load_fpr32(fp1, ft);
             gen_load_fpr32(fp2, fr);
-            tcg_gen_helper_1_3(do_float_nmulsub_s, fp2, fp0, fp1, fp2);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            gen_helper_float_nmulsub_s(fp2, fp0, fp1, fp2);
+            tcg_temp_free_i32(fp0);
+            tcg_temp_free_i32(fp1);
             gen_store_fpr32(fp2, fd);
-            tcg_temp_free(fp2);
+            tcg_temp_free_i32(fp2);
         }
         opn = "nmsub.s";
         break;
@@ -7626,36 +7587,36 @@ static void gen_flt3_arith (DisasContext *ctx, uint32_t opc,
         check_cop1x(ctx);
         check_cp1_registers(ctx, fd | fs | ft | fr);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp2 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
+            TCGv_i64 fp2 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
             gen_load_fpr64(ctx, fp2, fr);
-            tcg_gen_helper_1_3(do_float_nmulsub_d, fp2, fp0, fp1, fp2);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            gen_helper_float_nmulsub_d(fp2, fp0, fp1, fp2);
+            tcg_temp_free_i64(fp0);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp2, fd);
-            tcg_temp_free(fp2);
+            tcg_temp_free_i64(fp2);
         }
         opn = "nmsub.d";
         break;
     case OPC_NMSUB_PS:
         check_cp1_64bitmode(ctx);
         {
-            TCGv fp0 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp1 = tcg_temp_new(TCG_TYPE_I64);
-            TCGv fp2 = tcg_temp_new(TCG_TYPE_I64);
+            TCGv_i64 fp0 = tcg_temp_new_i64();
+            TCGv_i64 fp1 = tcg_temp_new_i64();
+            TCGv_i64 fp2 = tcg_temp_new_i64();
 
             gen_load_fpr64(ctx, fp0, fs);
             gen_load_fpr64(ctx, fp1, ft);
             gen_load_fpr64(ctx, fp2, fr);
-            tcg_gen_helper_1_3(do_float_nmulsub_ps, fp2, fp0, fp1, fp2);
-            tcg_temp_free(fp0);
-            tcg_temp_free(fp1);
+            gen_helper_float_nmulsub_ps(fp2, fp0, fp1, fp2);
+            tcg_temp_free_i64(fp0);
+            tcg_temp_free_i64(fp1);
             gen_store_fpr64(ctx, fp2, fd);
-            tcg_temp_free(fp2);
+            tcg_temp_free_i64(fp2);
         }
         opn = "nmsub.ps";
         break;
@@ -7699,11 +7660,11 @@ static void decode_opc (CPUState *env, DisasContext *ctx)
         MIPS_DEBUG("blikely condition (" TARGET_FMT_lx ")", ctx->pc + 4);
         tcg_gen_brcondi_i32(TCG_COND_NE, bcond, 0, l1);
         {
-            TCGv r_tmp = tcg_temp_new(TCG_TYPE_I32);
+            TCGv_i32 r_tmp = tcg_temp_new_i32();
 
             tcg_gen_movi_i32(r_tmp, ctx->hflags & ~MIPS_HFLAG_BMASK);
             tcg_gen_st_i32(r_tmp, cpu_env, offsetof(CPUState, hflags));
-            tcg_temp_free(r_tmp);
+            tcg_temp_free_i32(r_tmp);
         }
         gen_goto_tb(ctx, 1, ctx->pc + 4);
         gen_set_label(l1);
@@ -7758,7 +7719,7 @@ static void decode_opc (CPUState *env, DisasContext *ctx)
             MIPS_INVAL("PMON / selsl");
             generate_exception(ctx, EXCP_RI);
 #else
-            tcg_gen_helper_0_i(do_pmon, sa);
+            gen_helper_0i(pmon, sa);
 #endif
             break;
         case OPC_SYSCALL:
@@ -7878,24 +7839,24 @@ static void decode_opc (CPUState *env, DisasContext *ctx)
         case OPC_RDHWR:
             check_insn(env, ctx, ISA_MIPS32R2);
             {
-                TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
+                TCGv t0 = tcg_temp_local_new();
 
                 switch (rd) {
                 case 0:
                     save_cpu_state(ctx, 1);
-                    tcg_gen_helper_1_0(do_rdhwr_cpunum, t0);
+                    gen_helper_rdhwr_cpunum(t0);
                     break;
                 case 1:
                     save_cpu_state(ctx, 1);
-                    tcg_gen_helper_1_0(do_rdhwr_synci_step, t0);
+                    gen_helper_rdhwr_synci_step(t0);
                     break;
                 case 2:
                     save_cpu_state(ctx, 1);
-                    tcg_gen_helper_1_0(do_rdhwr_cc, t0);
+                    gen_helper_rdhwr_cc(t0);
                     break;
                 case 3:
                     save_cpu_state(ctx, 1);
-                    tcg_gen_helper_1_0(do_rdhwr_ccres, t0);
+                    gen_helper_rdhwr_ccres(t0);
                     break;
                 case 29:
                     if (env->user_mode_only) {
@@ -7917,12 +7878,12 @@ static void decode_opc (CPUState *env, DisasContext *ctx)
         case OPC_FORK:
             check_insn(env, ctx, ASE_MT);
             {
-                TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
-                TCGv t1 = tcg_temp_local_new(TCG_TYPE_TL);
+                TCGv t0 = tcg_temp_local_new();
+                TCGv t1 = tcg_temp_local_new();
 
                 gen_load_gpr(t0, rt);
                 gen_load_gpr(t1, rs);
-                tcg_gen_helper_0_2(do_fork, t0, t1);
+                gen_helper_fork(t0, t1);
                 tcg_temp_free(t0);
                 tcg_temp_free(t1);
             }
@@ -7930,10 +7891,10 @@ static void decode_opc (CPUState *env, DisasContext *ctx)
         case OPC_YIELD:
             check_insn(env, ctx, ASE_MT);
             {
-                TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
+                TCGv t0 = tcg_temp_local_new();
 
                 gen_load_gpr(t0, rs);
-                tcg_gen_helper_1_1(do_yield, t0, t0);
+                gen_helper_yield(t0, t0);
                 gen_store_gpr(t0, rd);
                 tcg_temp_free(t0);
             }
@@ -8005,37 +7966,37 @@ static void decode_opc (CPUState *env, DisasContext *ctx)
         case OPC_MFMC0:
 #ifndef CONFIG_USER_ONLY
             if (!env->user_mode_only) {
-                TCGv t0 = tcg_temp_local_new(TCG_TYPE_TL);
+                TCGv t0 = tcg_temp_local_new();
 
                 op2 = MASK_MFMC0(ctx->opcode);
                 switch (op2) {
                 case OPC_DMT:
                     check_insn(env, ctx, ASE_MT);
-                    tcg_gen_helper_1_1(do_dmt, t0, t0);
+                    gen_helper_dmt(t0, t0);
                     break;
                 case OPC_EMT:
                     check_insn(env, ctx, ASE_MT);
-                    tcg_gen_helper_1_1(do_emt, t0, t0);
+                    gen_helper_emt(t0, t0);
                     break;
                 case OPC_DVPE:
                     check_insn(env, ctx, ASE_MT);
-                    tcg_gen_helper_1_1(do_dvpe, t0, t0);
+                    gen_helper_dvpe(t0, t0);
                     break;
                 case OPC_EVPE:
                     check_insn(env, ctx, ASE_MT);
-                    tcg_gen_helper_1_1(do_evpe, t0, t0);
+                    gen_helper_evpe(t0, t0);
                     break;
                 case OPC_DI:
                     check_insn(env, ctx, ISA_MIPS32R2);
                     save_cpu_state(ctx, 1);
-                    tcg_gen_helper_1_0(do_di, t0);
+                    gen_helper_di(t0);
                     /* Stop translation as we may have switched the execution mode */
                     ctx->bstate = BS_STOP;
                     break;
                 case OPC_EI:
                     check_insn(env, ctx, ISA_MIPS32R2);
                     save_cpu_state(ctx, 1);
-                    tcg_gen_helper_1_0(do_ei, t0);
+                    gen_helper_ei(t0);
                     /* Stop translation as we may have switched the execution mode */
                     ctx->bstate = BS_STOP;
                     break;
@@ -8329,7 +8290,7 @@ gen_intermediate_code_internal (CPUState *env, TranslationBlock *tb,
                 if (env->breakpoints[j] == ctx.pc) {
                     save_cpu_state(&ctx, 1);
                     ctx.bstate = BS_BRANCH;
-                    tcg_gen_helper_0_i(do_raise_exception, EXCP_DEBUG);
+                    gen_helper_0i(raise_exception, EXCP_DEBUG);
                     /* Include the breakpoint location or the tb won't
                      * be flushed when it must be.  */
                     ctx.pc += 4;
@@ -8376,11 +8337,11 @@ gen_intermediate_code_internal (CPUState *env, TranslationBlock *tb,
         gen_io_end();
     if (env->singlestep_enabled) {
         save_cpu_state(&ctx, ctx.bstate == BS_NONE);
-        tcg_gen_helper_0_i(do_raise_exception, EXCP_DEBUG);
+        gen_helper_0i(raise_exception, EXCP_DEBUG);
     } else {
 	switch (ctx.bstate) {
         case BS_STOP:
-            tcg_gen_helper_0_0(do_interrupt_restart);
+            gen_helper_interrupt_restart();
             gen_goto_tb(&ctx, 0, ctx.pc);
             break;
         case BS_NONE:
@@ -8388,7 +8349,7 @@ gen_intermediate_code_internal (CPUState *env, TranslationBlock *tb,
             gen_goto_tb(&ctx, 0, ctx.pc);
             break;
         case BS_EXCP:
-            tcg_gen_helper_0_0(do_interrupt_restart);
+            gen_helper_interrupt_restart();
             tcg_gen_exit_tb(0);
             break;
         case BS_BRANCH:
